mod Maux

incl Mtex

incl Mtexrc

rem 
  \para \bf  Some primitive recursive functions.  \end 

rem 
  \para \it  Case discrimination function.  \end 

fun/3 D1 'Tex_f3_rec_d1'
  D1(0,y,z) = z
  D1(x+1,y,z) = y

rem 
  \para \it  Summation.  \end 

fun Sum 'Tex_f1_n_sum'
  Sum(0) = 0
  Sum(n+1) = Sum(n)+n+1

rem 
  \para \bf  Characteristic functions.  \end 

fun/2 Eqf 'Tex_f2_char_eqf'
  Eqf(x,y) = 1 <- x = y
  Eqf(x,y) = 0 <- x != y

fun/2 Nef 'Tex_f2_char_nef'
  Nef(x,y) = 1 <- x != y
  Nef(x,y) = 0 <- x = y

fun/2 Lef 'Tex_f2_char_lef'
  Lef(x,y) = 1 <- x <= y
  Lef(x,y) = 0 <- x > y

fun/2 Ltf 'Tex_f2_char_ltf'
  Ltf(x,y) = 1 <- x < y
  Ltf(x,y) = 0 <- x >= y

fun/2 Gef 'Tex_f2_char_gef'
  Gef(x,y) = 1 <- x >= y
  Gef(x,y) = 0 <- x < y

fun/2 Gtf 'Tex_f2_char_gtf'
  Gtf(x,y) = 1 <- x > y
  Gtf(x,y) = 0 <- x <= y

rem 
  \para \bf  Boolean functions.  \end 

fun Notf 'Tex_f1_bool_notf'
  Notf(1) = 0
  Notf(0) = 1

fun/2 Andf 'Tex_f2_bool_andf'
  Andf(1,1) = 1
  Andf(1,0) = 0
  Andf(0,1) = 0
  Andf(0,0) = 0

fun/2 Orf 'Tex_f2_bool_orf'
  Orf(1,1) = 1
  Orf(1,0) = 1
  Orf(0,1) = 1
  Orf(0,0) = 0

fun/2 Impf 'Tex_f2_bool_impf'
  Impf(1,1) = 1
  Impf(1,0) = 0
  Impf(0,1) = 1
  Impf(0,0) = 1

fun/2 Ifff 'Tex_f2_bool_ifff'
  Ifff(1,1) = 1
  Ifff(1,0) = 0
  Ifff(0,1) = 0
  Ifff(0,0) = 1

rem 
  \para \bf  Catalan pairing function.  \end 

rem 
  \para \it  Pairing function.  \end 

fun/2 Pair 'Tex_f2_pp_pair'
  Pair(x,y) = x,y

rem 
  \para \it  Projection functions.  \end 

fun Proj1 'Tex_f1_pp_proj1'
  Proj1(x) = H(x)

fun Proj2 'Tex_f1_pp_proj2'
  Proj2(x) = T(x)

rem 
  \para \it  Unary iteration of the second projection.  \end 

fun/2 Iproj2 'Tex_f2_pp_iproj2'
  Iproj2(0,x) = x
  Iproj2(n+1,x) = Iproj2(n,Proj2(x))

rem 
  \para \bf  Tuples.  \end 

pred/2 Tuple 
  Tuple(n,x) <-> n = 0 & x = 0 \/ n = 1 \/ n >= 2 & Iproj2(n-2,x) != 0

fun/3 Proj 'Tex_f3_pp_proj'
  Proj(n,x,i) = Proj1 Iproj2(i-1,x) <- i != n
  Proj(n,x,i) = Iproj2(n-1,x) <- i = n

rem 
  \para \bf  Finite sequences.  \end 

rem 
  \para \it  Length of sequences.  \end 

fun L 
  L(0) = 0
  L(v,w) = L(w)+1

rem 
  \para \it  Indexing function.  \end 

fun/2 Sub 'Tex_f2_pp_sub'
  Sub((v,w),0) = v
  Sub((v,w),i+1) = Sub(w,i)

